<?php

class ClientPage extends ClientGroup {

	static $has_one = array(
		'Photo' => 'Image',
		'ClientPage' => 'ClientPage'
	);
	
	static $many_many = array(
		'ClientMembers' => 'ClientMember'
	);
	
	static $allowed_children = array( 'ClientMember' );	
	
	function getCMSFields(){
      $fields = parent::getCMSFields();

		$fields->addFieldToTab('Root.Content.Client picture', new ImageField('Photo'));
		
		$MembersTableField = new ComplexTableField(
			$this,
			'ClientMembers',
			'Member',
		array(
			'FirstName' => 'First name',
			'Surname' => 'Surname',
			'Nickname' => 'Nickname',
			'Email' => 'Email',
			'Password' => 'Password'
		),
			'getCMSFields_forPopup'
		);
		
		$MembersTableField->setParentClass('ClientPage');
		
		$fields->addFieldToTab('Root.Content.Add members', $MembersTableField);
		
		$MembersTableField->setAddTitle('a member');

		$validator = new RequiredFields('PageName');
		
		return $fields;
   }

	static $has_written = false;

	function onBeforeWrite(){
		if($this->Title != "New ClientPage" && !DataObject::get_one('Group', "Title = '$this->Title'")){
			if(!self::$has_written){ // hack to ensure new security group isn't written multiple times
					$member = new Member();
					$member->FirstName = 'FirstName';
					$member->Surname = 'Surname';
					$member->Nickname = 'Nickname';
					$member->Email = 'Email';
					$member->Password = 'Password';
					$member->write();
					$group = new Group();
					$group->Code = 'CMSMain';
					$group->Title = $this->Title;
					$group->Members()->add($member);
					$group->write();
					Permission::grant($group->ID, "CMSMain");
				}
			self::$has_written = true;
		}
		parent::onBeforeWrite();
	}
}

class ClientPage_Controller extends Page_Controller{
}
?>